#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.XlsIO;
using System.IO;
using Syncfusion.WinForms.DataGridConverter;
using Syncfusion.WinForms.DataGridConverter.Events;

namespace ExcelExporting
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            sfDataGrid1.AutoGenerateColumns = false;
            ProductInfoRepository pro = new ProductInfoRepository();
            sfDataGrid1.DataSource = pro.ProductInfo;
            GridSettings();

            sfDataGrid1.TableControl.MouseMove += TableControl_MouseMove;
            sfDataGrid1.QueryCellStyle += sfDataGrid1_QueryCellStyle;
            sfDataGrid1.TableControl.MouseLeave += TableControl_MouseLeave;
        }
        int hoveredRowIndex = -1;

        void TableControl_MouseLeave(object sender, EventArgs e)
        {
            //To remove the hovered row color while the mouse is leaves the SfDataGrid.
            sfDataGrid1.TableControl.Invalidate(sfDataGrid1.TableControl.GetRowRectangle(hoveredRowIndex, true));
            hoveredRowIndex = -1;
        }

        void sfDataGrid1_QueryCellStyle(object sender, Syncfusion.WinForms.DataGrid.Events.QueryCellStyleEventArgs e)
        {
            if (e.RowIndex == hoveredRowIndex)
            {
                //Set the back color for the hovered row cells.
                e.Style.BackColor = Color.Yellow;
            }
        }

        void TableControl_MouseMove(object sender, MouseEventArgs e)
        {
            var rowColumnIndex = this.sfDataGrid1.TableControl.PointToCellRowColumnIndex(this.sfDataGrid1.TableControl.PointToClient(Cursor.Position));

            // Update the hovered row index.
            if (hoveredRowIndex != rowColumnIndex.RowIndex)
            {
                sfDataGrid1.TableControl.Invalidate(sfDataGrid1.TableControl.GetRowRectangle(hoveredRowIndex,true));
                hoveredRowIndex = rowColumnIndex.RowIndex;
                sfDataGrid1.TableControl.Invalidate(sfDataGrid1.TableControl.GetRowRectangle(hoveredRowIndex, true));
            }             
        }     

        private void GridSettings()
        {
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "SupplierID", HeaderText = "Supplier ID" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "ProductID", HeaderText = "Product ID" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "ProductName", HeaderText = "Product Name" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "QuantityPerUnit", HeaderText = "Quantity Per Unit" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "UnitPrice", HeaderText = "Price" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "UnitsInStock", HeaderText = "Units In Stock" });
        }             
    }
}
